﻿using System;
using System.ComponentModel;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Web;

/// <summary>
/// Summary description for PersonRepository
/// </summary>
public class PersonRepository : FakeRepository<Person>
{
    public PersonRepository() { }

    public PersonRepository(string persistenceKey)
    {
        this.AddCacheUniqeKey(persistenceKey);
    }

    public string GetDelimitedIDString(char delimiter)
    {
        StringBuilder ids = new StringBuilder();
        foreach (Person person in this.List)
        {
            ids.AppendFormat("{0}{1}", person.Id, delimiter);
        }

        return ids.ToString().TrimEnd(delimiter);
    }

    [DataObjectMethod(DataObjectMethodType.Insert, true)]
    public virtual void Insert(string firstName, string lastName)
    {
        var person = new Person() 
        { 
            FirstName =  firstName,
            LastName = lastName
        };

        this.Insert(person);
    }

    [DataObjectMethod(DataObjectMethodType.Update, true)]
    public virtual void Update(int id, string firstName, string lastName)
    {
        var person = new Person()
        {
            FirstName = firstName,
            LastName = lastName,
            Id = id
        };

        this.Update(person);
    }

    [DataObjectMethod(DataObjectMethodType.Delete, true)]
    public override void Delete(int id)
    {
        base.Delete(id);
    }

    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public override IList<Person> GetAll()
    {
        return base.GetAll();
    }
}
