﻿using System;
using System.Web;
using System.Web.Services;

public partial class WebDataGrid_DragAndDropRows_test_Default : System.Web.UI.Page
{
    private PersonRepository _source;
    private PersonRepository _destination;

    protected string IDList
    {
        get { return _source.GetDelimitedIDString(','); }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        this._source = new PersonRepository("src");
        this._destination = new PersonRepository("dest");
        this.AddFakeData();
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        this.wdgSource.DataSource = this._source.GetAll();
        this.wdgSource.Visible = this.wdgSource.Rows.Count > 0;

        this.wdgDestination.DataSource = this._destination.GetAll();
    }

    protected void person_Drag(object sender, EventArgs e)
    {
        int id;

        if (int.TryParse(this.personId.Value, out id))
        {
            if (id > 0)
            {
                var person = this._source.GetById(id);
                this._source.Delete(person.Id);
                this._destination.Insert(person);
            }
        }
    }

    #region Add Fake Data
    private void AddFakeData()
    {
        if (this._source.IsEmpty)
        {
            this._source.Insert(new Person() { FirstName = "Jacob", LastName = "Jones" });
            this._source.Insert(new Person() { FirstName = "Jeremy", LastName = "Jones" });
            this._source.Insert(new Person() { FirstName = "James", LastName = "Jones" });
            this._source.Insert(new Person() { FirstName = "Jane", LastName = "Jones" });
        }

        if (this._destination.IsEmpty)
        {
            this._destination.Insert(new Person() { FirstName = "Sammy", LastName = "Smith" });
            this._destination.Insert(new Person() { FirstName = "Sol", LastName = "Smith" });
            this._destination.Insert(new Person() { FirstName = "Sarah", LastName = "Smith" });
        }
    }
    #endregion
}
